# -*- mode: ruby -*-
VAGRANTFILE_API_VERSION = "2"
BOX_IMAGE = "generic/ubuntu2204"

node = {
  'app01' => { :ip => "192.168.88.90",  :cpus => 2, :mem => 2024 },
  'mon01' => { :ip => "192.168.88.91",  :cpus => 2, :mem => 6024 },
#  'prom01' => { :ip => "192.168.88.92",  :cpus => 2, :mem => 2024 },
#  'arm01' => { :ip => "192.168.88.93",  :cpus => 2, :mem => 2024 },
}

Vagrant.configure(VAGRANTFILE_API_VERSION) do |config|

    node.each_with_index do |(hostname, info), index|
      config.vm.define hostname do |cfg|
        cfg.vm.provider "virtualbox" do |vb, override|
          config.vm.box = BOX_IMAGE
          override.vm.network "public_network", bridge: "enp6s0" , ip: "#{info[:ip]}"
          override.vm.hostname = hostname
          vb.name = hostname
          vb.customize ["modifyvm", :id, "--memory", info[:mem], "--cpus", info[:cpus], "--hwvirtex", "on"]
        end

    if index == node.size - 1
      config.vm.provision "ansible" do |ansible|
        ansible.playbook = "./.ansible/playbook.yml"
        ansible.galaxy_role_file = "./.ansible/requirements.yml"
        ansible.galaxy_roles_path = "./.ansible/roles"

        ansible.groups = {
            "app" => ["app01"],
            "mon" => ["mon01"],
            "prom" => ["prom01"],
            "arm" => ["arm01"],
            "mon:vars" => {"elasticsearch_network_host" => "localhost",
                "elasticsearch_http_port" => "9200",
                "elasticsearch_extra_options" => "",
                "elasticsearch_path_data" => "/var/lib/elasticsearch",
                "elasticsearch_path_log" => "/var/log/elasticsearch ",
                "elasticsearch_user" => "user1",
                "elasticsearch_password" => "graf0081",
#                "kibana_server_host" => "0.0.0.0",
                "kibana_elasticsearch_user" => "kibana_system",
                "kibana_elasticsearch_password" => "{{ kibana_password.stdout }}",
                "nginx_custom_cofig_file" => "proxy.conf.j2"
            },
        }
        end
      end
    end
  end
end